﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using EJ2Grid.Models;
using Syncfusion.EJ2.Base;
using System.Collections;
using System.ComponentModel.DataAnnotations;

namespace EJ2Grid.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();
        public static List<Ordersone> orderone = new List<Ordersone>();
        public static List<Orderstwo> ordertwo = new List<Orderstwo>();
        public IActionResult Index()
        {
            ViewBag.DataSource = Orders.getAllRecords().ToList();
            ViewBag.DataSource = Ordersone.getAllRecords().ToList();
            ViewBag.DataSource = Orderstwo.getAllRecords().ToList();
            return View();
        }

        public IActionResult UrlDatasource([FromBody]DataManagerRequest dm)
        {
            IEnumerable DataSource = order;
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<Orders>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        public IActionResult Insert([FromBody]CRUDModel<Orders> value)
        {
            order.Insert(0, value.Value);
            return Json(value.Value);
        }

        public ActionResult BatchUpdate([FromBody]CRUDModel batchmodel)
        {
            if (batchmodel.Changed != null)
            {
                for (var i = 0; i < batchmodel.Changed.Count(); i++)
                {

                    var ord = batchmodel.Changed[i];
                    Orders val = Orders.getAllRecords().Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
                    val.OrderID = ord.OrderID;
                    val.EmployeeID = ord.EmployeeID;
                    val.CustomerID = ord.CustomerID;
                    val.Freight = ord.Freight;
                    val.OrderDate = ord.OrderDate;
                    val.ShipCity = ord.ShipCity;
                    val.ShipCountry = ord.ShipCountry;
                }
            }

            if (batchmodel.Deleted != null)
            {
                for (var i = 0; i < batchmodel.Deleted.Count(); i++)
                {
                    Orders.getAllRecords().Remove(Orders.getAllRecords().Where(or => or.OrderID == batchmodel.Deleted[i].OrderID).FirstOrDefault());
                }
            }

            if (batchmodel.Added != null)
            {
                for (var i = 0; i < batchmodel.Added.Count(); i++)
                {
                    Orders.getAllRecords().Insert(0, batchmodel.Added[i]);
                }
            }
            var data = Orders.getAllRecords().ToList();
            return Json(data);

        }
        public IActionResult Update([FromBody]CRUDModel<Orders> model)
        {
            var data = order.Where(or => or.OrderID == model.Value.OrderID).FirstOrDefault();
            if (data != null)
            {
                data.OrderID = model.Value.OrderID;
                data.CustomerID = model.Value.CustomerID;
                data.EmployeeID = model.Value.EmployeeID;
                data.OrderDate = model.Value.OrderDate;
                data.ShipCity = model.Value.ShipCity;
                data.Freight = model.Value.Freight;
            }
            return Json(model.Value);
        }
        public void Remove([FromBody]CRUDModel<Orders> Value)
        {
            var data = order.Where(or => or.OrderID.Equals(Value.Key)).FirstOrDefault();
            order.Remove(data);
        }

        public class CRUDModel
        {
            public List<Orders> Added { get; set; }
            public List<Orders> Changed { get; set; }
            public List<Orders> Deleted { get; set; }
            public Orders Value { get; set; }
            public int key { get; set; }
            public string action { get; set; }
        }
        public IActionResult UrlDatasourceone([FromBody]DataManagerRequest dm)
        {
            IEnumerable DataSource = orderone;
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<Ordersone>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        [HttpPost]
        public IActionResult Insertone([FromBody]CRUDModel<Ordersone> value)
        {
            orderone.Insert(0, value.Value);
            return Json(value.Value);
        }

        public IActionResult Updateone([FromBody]CRUDModel<Ordersone> model)
        {
            var data = orderone.Where(or => or.OrderID == model.Value.OrderID).FirstOrDefault();
            if (data != null)
            {
                data.OrderID = model.Value.OrderID;
                data.Quantity = model.Value.Quantity;
                data.MRP = model.Value.MRP;
                data.Discount = model.Value.Discount;
                data.Discountprice = model.Value.Discountprice;
                data.Total = model.Value.Total;
            }
            return Json(model.Value);
        }
        public void Removeone([FromBody]CRUDModel<Ordersone> Value)
        {
            var data = orderone.Where(or => or.OrderID.Equals(Value.Key)).FirstOrDefault();
            orderone.Remove(data);
        }

        public IActionResult UrlDatasourcetwo([FromBody]DataManagerRequest dm)
        {
            IEnumerable DataSource = ordertwo;
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<Orderstwo>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        [HttpPost]
        public IActionResult Inserttwo([FromBody]CRUDModel<Orderstwo> value)
        {
            ordertwo.Insert(0, value.Value);
            return Json(value.Value);
        }

        public IActionResult Updatetwo([FromBody]CRUDModel<Orderstwo> model)
        {
            var data = ordertwo.Where(or => or.OrderID == model.Value.OrderID).FirstOrDefault();
            if (data != null)
            {
                data.OrderID = model.Value.OrderID;
                data.Name = model.Value.Name;
            }
            return Json(model.Value);
        }
        public ActionResult GetDesignTemplate(int id)
        {
            var data = ordertwo.FirstOrDefault(k => k.OrderID == id);
            return Json(data);
        }
        public void Removetwo([FromBody]CRUDModel<Orderstwo> Value)
        {
            var data = ordertwo.Where(or => or.OrderID.Equals(Value.Key)).FirstOrDefault();
            ordertwo.Remove(data);
        }

        public class CRUDModelone
        {
            public List<Ordersone> Added { get; set; }
            public List<Ordersone> Changed { get; set; }
            public List<Ordersone> Deleted { get; set; }
            public Ordersone Value { get; set; }
            public int key { get; set; }
            public string action { get; set; }
        }

        public class Ordersone
        {
            public Ordersone()
            {

            }
            public Ordersone(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity, string ShipCountry, int Quantity, int MRP, int Discount, int? Discountprice, int? Total)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
                this.ShipCountry = ShipCountry;
                this.Quantity = Quantity;
                this.MRP = MRP;
                this.Discount = Discount;
                this.Discountprice = Discountprice;
                this.Total = Total;
            }

            public static List<Ordersone> getAllRecords()
            {
                if (orderone.Count == 0)
                {
                    int code = 10000;
                    for (int i = 1; i < 10; i++)
                    {
                        orderone.Add(new Ordersone(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin", "Denmark", 1, 1000, 20, null , null ));
                        orderone.Add(new Ordersone(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid", "Brazil", 2, 2000, 10, null, null));
                        orderone.Add(new Ordersone(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester", "Germany", 2, 3000, 10, null, null));
                        orderone.Add(new Ordersone(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille", "Austria", 3, 3000, 20, null, null));
                        orderone.Add(new Ordersone(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen", "Switzerland", 4, 4000, 20, null, null));
                        code += 5;
                    }
                }
                return orderone;
            }

            public long OrderID { get; set; }
            [Required]
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
            public string ShipCountry { get; set; }
            public int Quantity { get; set; }
            public int MRP { get; set; }
            public int Discount { get; set; }
            public int? Discountprice { get; set; }
            public int? Total { get; set; }
        }

        public class Orderstwo
        {
            public Orderstwo()
            {

            }
            public Orderstwo(long OrderId, string Name)
            {
                this.OrderID = OrderId;
                this.Name = Name;
            }

            public static List<Orderstwo> getAllRecords()
            {
                if (ordertwo.Count == 0)
                {
                    int code = 10000;
                    for (int i = 1; i < 10; i++)
                    {
                        ordertwo.Add(new Orderstwo(code + 1, "Name1"));
                        ordertwo.Add(new Orderstwo(code + 2, "Name2"));
                        ordertwo.Add(new Orderstwo(code + 3, "Name3"));
                        ordertwo.Add(new Orderstwo(code + 4, "Name4"));
                        ordertwo.Add(new Orderstwo(code + 5, "Name5"));
                        code += 5;
                    }
                }
                return ordertwo;
            }

            public long OrderID { get; set; }
            public string Name { get; set; }
        }

        public class CRUDModeltwo
        {
            public List<Orderstwo> Added { get; set; }
            public List<Orderstwo> Changed { get; set; }
            public List<Orderstwo> Deleted { get; set; }
            public Orderstwo Value { get; set; }
            public int key { get; set; }
            public string action { get; set; }
        }

        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity, string ShipCountry)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
                this.ShipCountry = ShipCountry;
            }

            public static List<Orders> getAllRecords()
            {
                if (order.Count == 0)
                {
                    int code = 10000;
                    for (int i = 1; i < 10; i++)
                    {
                        order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin", "Denmark"));
                        order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid", "Brazil"));
                        order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester", "Germany"));
                        order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille", "Austria"));
                        order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen", "Switzerland"));
                        code += 5;
                    }
                }
                return order;
            }

            public long OrderID { get; set; }
            [Required]
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
            public string ShipCountry { get; set; }
        }
    }
}
